/*
*  Rubrica
*  file: error.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
/* 
   Per favore non eliminate i commenti in italiano 
   Non tutti gli italiani conoscono l'inglese.
*/

#include <gnome.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include "main.h"
#include "rubrica_log.h"
#include "error.h"


void rubrica_error_preferences_key(gchar *str)
{
  gchar *buffer;

  buffer = g_strdup_printf(_("\nCan't read configuration values from gconf for %s key"),str);

  g_print(buffer);
  rubrica_log_write_log(buffer);
  
  g_free(buffer);
}

void rubrica_error_loading_preferences_keys(void)
{
  GtkWidget *dialogo;
  gchar *buffer;

  buffer = g_strdup_printf(_("Can't read configuration values from gconf.\nMay be rubrica.schemas isn't installed rigth way\n\nExec gconftool --makefile-install-rule=rubrica.schemas\nYou can find rubrica.schemas in the /etc/gconf/schema directory.\n\nrubrica.log file contains unread keys."));

  dialogo = gnome_warning_dialog(buffer);
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(dialogo);

  rubrica_log_write_log(buffer);
  g_free(buffer);
}

void rubrica_error_display_preferences_messages(gchar *str)
{
  g_print("\n\nPlease send this message to nicolafragale@libero.it\nLa routine %s non riesce a leggere le preferenze, n quelle impostate dall'utente, n dal file schema", 
	  str);
}


void 
rubrica_error_selezionare_elemento(void)
{
  GtkWidget *messagebox;
  GtkWidget *button1;

  messagebox = gnome_message_box_new (_("Warning!\nYou must select a card, before continue."),
				      GNOME_MESSAGE_BOX_ERROR, NULL);

  gtk_container_set_border_width (GTK_CONTAINER (messagebox), 5);
  gtk_window_set_title (GTK_WINDOW (messagebox), _("Info"));
  gtk_window_set_position (GTK_WINDOW (messagebox), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (messagebox), TRUE);
  gtk_window_set_policy (GTK_WINDOW (messagebox), FALSE, FALSE, FALSE);

  gnome_dialog_append_button (GNOME_DIALOG (messagebox), GNOME_STOCK_BUTTON_OK);
  button1 = g_list_last (GNOME_DIALOG (messagebox)->buttons)->data;
  gtk_widget_show (button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  gtk_widget_show(messagebox);
}


void 
rubrica_error_cancellazione(void)
{
  GtkWidget *dialogo/*, *label*/ ;

/*  
  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_OK, NULL);
  label = gtk_label_new(_("Warning!\nI can't delete the selected card"));
*/
  dialogo = gnome_warning_dialog(_("Warning!\nI can't delete the selected card"));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
//  gtk_widget_show(label);
//  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));
}


void 
rubrica_error_modifica(void)
{
  GtkWidget *dialogo, *label;

  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_OK, NULL);
  label =  gtk_label_new(_("Warning!\nI can't modify the selected card."));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));
}


void 
rubrica_non_implementato(void)
{
  GtkWidget *dialogo, *label;

  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_OK, NULL);
  label = gtk_label_new(_("Warning!\nThis function isn't yet implemented\n"));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));  
}

void 
rubrica_error_rubrica_empty()
{
  GtkWidget *dialogo, *label;
  
  dialogo = gnome_dialog_new(_("Warning"), GNOME_STOCK_BUTTON_OK, NULL);
  label = gtk_label_new(_("Warning!\nAddress book is empty. I can't continue\n"));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, TRUE, TRUE, 0);

  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));  
}

void rubrica_error_no_item_found(void)
{
  rubrica_non_implementato();
}

void rubrica_error_no_string(void)
{
  rubrica_non_implementato();
}

void rubrica_error_import_no_file(void)
{
  GtkWidget *dialogo, *label;

  dialogo = gnome_dialog_new(_("Error"), GNOME_STOCK_BUTTON_OK, NULL);
  label =  gtk_label_new(_("Error!\nI can't read the file."));
  gtk_window_set_modal (GTK_WINDOW (dialogo), TRUE);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialogo)->vbox), label, 
		     TRUE, TRUE, 0);
  gnome_dialog_run_and_close(GNOME_DIALOG(dialogo));
}


void rubrica_error_display_error(GtkWidget *parent, gchar *file, RUBRICA_ERROR err)
{
  GtkWidget *dlg;
  gchar *str;

  switch (err)
    {
    case RUBRICA_ERROR_FILE_NOT_EXIST:
      str = g_strdup_printf(_("I can't read %s.\nFile don't exist."), file);  
      
      if (parent)
	{
	  dlg = gnome_error_dialog_parented(str, GTK_WINDOW(parent));
	  gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
	}
      else
	rubrica_error_generic(str);

      g_free(str);
      break;
      
    case RUBRICA_ERROR_PARSE_XML_DOC:
      str = g_strdup_printf(_("I can't parse xml structure of file: %s."), file);  

      if (parent)
	{
	  dlg = gnome_error_dialog_parented(str, GTK_WINDOW(parent));
	  gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
	}
      else     
	rubrica_error_generic(str);

      g_free(str);	  
      break;
      
    case RUBRICA_ERROR_XML_DOC_NO_RUBRICA_HEADER:
      str = g_strdup_printf(_("Header error.\n%s is not a rubrica file\nOr this file is corrupted"), file);  

      if (parent)
	{
	  dlg = gnome_error_dialog_parented(str, GTK_WINDOW(parent));
	  gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
	}
      else
	rubrica_error_generic(str);
      
      g_free(str);
      break;
      
    default:
      str = g_strdup(_("I can't load default addressbook."));

      if (parent)
	{
	  dlg = gnome_error_dialog_parented(str, GTK_WINDOW(parent));
	  gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
	}
      else     
	rubrica_error_generic(str);
      
      g_free(str);
      break;
    }
}
  
  
void rubrica_error_generic(gchar *str)
{
  GtkWidget *generic_error;
  GtkWidget *dialog_vbox1;
  GtkWidget *button1;
  GtkWidget *dialog_action_area1;

  /* We create it with an OK button, and then remove the button, to work
     around a bug in gnome-libs. */
  g_warning("%s", str);
  generic_error = gnome_message_box_new (str,
                              GNOME_MESSAGE_BOX_ERROR,
                              GNOME_STOCK_BUTTON_OK, NULL);
  gtk_container_remove (GTK_CONTAINER (GNOME_DIALOG (generic_error)->action_area), 
			GNOME_DIALOG (generic_error)->buttons->data);
  GNOME_DIALOG (generic_error)->buttons = NULL;
  gtk_object_set_data (GTK_OBJECT (generic_error), "generic_error", generic_error);
  gtk_window_set_title (GTK_WINDOW (generic_error), _("Error"));
  gtk_window_set_position (GTK_WINDOW (generic_error), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (generic_error), TRUE);

  dialog_vbox1 = GNOME_DIALOG (generic_error)->vbox;
  gtk_object_set_data (GTK_OBJECT (generic_error), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  gnome_dialog_append_button (GNOME_DIALOG (generic_error), GNOME_STOCK_BUTTON_OK);
  button1 = GTK_WIDGET (g_list_last (GNOME_DIALOG (generic_error)->buttons)->data);
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (generic_error), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  dialog_action_area1 = GNOME_DIALOG (generic_error)->action_area;
  gtk_widget_ref (dialog_action_area1);
  gtk_object_set_data_full (GTK_OBJECT (generic_error), "dialog_action_area1", 
			    dialog_action_area1,(GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_show(generic_error);
}


void rubrica_message(gchar *str)
{
  GtkWidget *message;
  GtkWidget *dialog_vbox1;
  GtkWidget *button1;

  /* We create it with an OK button, and then remove the button, to work
     around a bug in gnome-libs. */
  message = gnome_message_box_new (str, GNOME_MESSAGE_BOX_INFO, GNOME_STOCK_BUTTON_OK, 
				   NULL);
  gtk_container_remove (GTK_CONTAINER (GNOME_DIALOG (message)->action_area), 
			GNOME_DIALOG (message)->buttons->data);
  GNOME_DIALOG (message)->buttons = NULL;
  gtk_container_set_border_width (GTK_CONTAINER (message), 5);
  gtk_window_set_title (GTK_WINDOW (message), _("Info"));
  gtk_window_set_modal (GTK_WINDOW (message), TRUE);
  gtk_window_set_policy (GTK_WINDOW (message), FALSE, FALSE, FALSE);

  dialog_vbox1 = GNOME_DIALOG (message)->vbox;
  gtk_widget_show (dialog_vbox1);

  gnome_dialog_append_button (GNOME_DIALOG (message), GNOME_STOCK_BUTTON_OK);
  button1 = GTK_WIDGET (g_list_last (GNOME_DIALOG (message)->buttons)->data);
  gtk_widget_show (button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  gtk_widget_show(message);
}







