/*
*  Rubrica
*  file: export_cb.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gnome.h>
#include "error.h"

void
on_export_file_clicked (GtkButton *button, gpointer user_data)
{
  GtkWidget *dialog = user_data;
  GtkWidget *entry;
  GtkWidget *gnome_entry;
  GtkWidget *fileentry;

  gchar buffer[256];
  gchar *htmlout;
  gchar *html;
  gchar *rubin;
  gchar *script = NULL;
  gchar *style  = NULL;


  if (g_file_exists("/usr/share/rubrica/script/rub2html.py"))
    script = g_strdup("/usr/share/rubrica/script/rub2html.py");

  if (g_file_exists("/usr/local/share/rubrica/script/rub2html.py"))
    script = g_strdup("/usr/local/share/rubrica/script/rub2html.py");
  
  if (!script)
    {
      rubrica_error_generic(_("Can't find the script rub2html.py\nI can't export this file."));

      return;
    }
    
  if (g_file_exists("/usr/share/rubrica/stylesheet/rub2html.xsl"))
    style = g_strdup("/usr/share/rubrica/stylesheet/rub2html.xsl");

  if (g_file_exists("/usr/local/share/rubrica/stylesheet/rub2html.xsl"))
    style = g_strdup("/usr/local/share/rubrica/stylesheet/rub2html.xsl");
  
  if (!style)
    {
      rubrica_error_generic(_("Can't find the stylesheet rub2html.xsl\nI can't export this file."));

      return;
    }
  
  entry = gtk_object_get_data(GTK_OBJECT(dialog), "entry");
  fileentry = gtk_object_get_data(GTK_OBJECT(dialog), "fileentry");
  gnome_entry = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (fileentry));

  rubin = html = htmlout = "";

  rubin = gtk_entry_get_text(GTK_ENTRY(gnome_entry));
  if (strcmp(rubin, "") == 0)
    {
      rubrica_error_generic(_("You must select the file that want to export")); 

      return;
    }

  htmlout = gtk_entry_get_text(GTK_ENTRY(entry));
  if (strcmp(htmlout, "") == 0)
    {
      rubrica_error_generic(_("\nI need a name for html file ")); 

      return;
    }
  else
    {
      gchar *tmp;

      tmp = g_get_home_dir();

      html = g_strdup_printf("%s/.rubrica/%s", tmp, htmlout);
    }

  if (!g_file_exists(style))
    {
      rubrica_error_generic(_("\nCan't find stylesheet document\nI can't perform export"));    

      return;
    }
  
  
  sprintf(buffer, "%s %s %s %s", script, rubin, html, style);
  system(buffer);
  
  rubrica_message(_("File has been exported"));

  gtk_widget_destroy(dialog);
}
